function QLR=QLR_star_calc_startsearch2(beta_start_mat,beta0,D,xi,Sigmagg_inv,Sigma_tg,Omega,Big_sigma_inv_mat)
%Calculates QLR statistic for the null that true value is beta0
D_vec=D(1:end)';
if size(D_vec,2)>1
    D_vec=D_vec';
end
G_draw=D_vec+Sigma_tg*Sigmagg_inv*xi;
G_draw=reshape(G_draw,length(xi),length(beta0));

beta_diff=beta_start_mat-repmat(beta0',size(beta_start_mat,1),1);
big_G_sum=zeros(length(xi)*size(beta_start_mat,1),1);
for n=1:size(beta_start_mat,2)
    big_G_sum=big_G_sum+kron(beta_diff(:,n),G_draw(:,n));
end
f_b_big=repmat(xi,size(beta_start_mat,1),1)-...
    sum(kron(beta_diff,ones(length(xi),1)).*repmat(G_draw,size(beta_start_mat,1),1),2);

xi_product=Big_sigma_inv_mat*xi;
big_G_product=Big_sigma_inv_mat*G_draw;
f_b_big_product=xi_product-sum(kron(beta_diff,ones(length(xi),1)).*big_G_product,2);
f_b_final_product=f_b_big_product.*f_b_big;
obj_init_vec=kron(eye(size(beta_start_mat,1)),ones(1,length(xi)))*f_b_final_product;
[obj_init_min, obj_init_min_loc]=min(obj_init_vec);
init_val=beta_start_mat(obj_init_min_loc,:)';

obj=@(b) S_star_calc(b,beta0,D,xi,Sigmagg_inv,Sigma_tg,Omega);
options=optimset('MaxFunEvals',10^4,'MaxIter',10^4);
beta_hat=fminsearch(obj,init_val,options);
opt_obj=obj(beta_hat);

QLR_min=min([opt_obj obj_init_min]);

QLR=obj(beta0)-QLR_min;
end