%Code by Isaiah Andrews, December 2015
rng(1);

worker_count=24;
while worker_count>=12
    try
        parpool('local',worker_count)
    end
    n = numlabs;
    if n==worker_count
        worker_count=0;
    else
        worker_count=worker_count-2;
    end
end


load Powerblock_dk1_dj3_1Msims

tic
instruments=length(mu);
sims=5*10^3;

b_integration_draws=1000;
S_approximation_draws=5000;
size_sims=10000;
beta0=0;
e2=[0;1];

Sigma_gg=Sigma(1:length(mu),1:length(mu));
Sigma_standardized=kron(eye(2),Sigma_gg^-.5)*Sigma*kron(eye(2),Sigma_gg^-.5);
Sigma_tg=Sigma_standardized(length(mu)+1:end,1:length(mu));
Sigma_tt=Sigma_standardized(length(mu)+1:end,length(mu)+1:end);
Sigma_D=Sigma_tt-Sigma_tg*Sigma_tg';
mu=Sigma_gg^-.5*mu;

%set grid of alternatives for power simulation
betagrid=(-6:.3:6)/norm(mu);

%set grids for use in calculating PI test
lambda_grid=(-5:0.1:5);
tau_grid_count=1000;
PI_sims=10000;

D_noise_base=randn(sims,instruments);
D_noise_base2=randn(PI_sims,instruments);

g_noise=randn(sims,instruments);

K_size=sum(randn(size_sims,dimK).^2,2);
J_size=sum(randn(size_sims,dimJ).^2,2);

CLR_test=zeros(sims,length(betagrid));
PI_test=zeros(sims,length(betagrid));
S_test=zeros(sims,length(betagrid));
K_test=zeros(sims,length(betagrid));
astore=zeros(sims,length(betagrid));
astore_CLR=zeros(sims,length(betagrid));
rkstore=zeros(sims,length(betagrid));

b0=[1; -beta0];
a0=[beta0; 1];

[Omega, Phi]=krondecomp(Sigma_standardized, 2, instruments, 2, instruments);
Omega=-Omega;
Phi=-Phi;
Phi=(Phi+Phi')/2;

MM1_sigma2=obs/10;
MM2_varsigma=obs/10;

b_integration=randn(b_integration_draws,1)+beta0;
theta_integration=rand(b_integration_draws,1)*2*pi-pi;
S2=randn(S_approximation_draws,instruments);
C_beta0=(kron(b0',eye(instruments))*Sigma_standardized*kron(b0,eye(instruments)))^-.5;
c01_store=zeros(sims,length(betagrid));
c11_store=zeros(sims,length(betagrid),instruments);
MM1_stat_store=zeros(sims,length(betagrid));
MM1_test_store=zeros(sims,length(betagrid));
exitflag_store1=zeros(sims,length(betagrid));

c02_store=zeros(sims,length(betagrid));
c12_store=zeros(sims,length(betagrid),instruments);
MM2_stat_store=zeros(sims,length(betagrid));
MM2_test_store=zeros(sims,length(betagrid));
exitflag_store2=zeros(sims,length(betagrid));
for k=1:length(betagrid)
    parfor n=1:sims
        %for n=1:sims
        [k/length(betagrid) n/sims]
        D_noise=D_noise_base*(Sigma_D^.5);
        D_noise2=D_noise_base2*(Sigma_D^.5);
        
        D=D_noise(n,:)';
        D=D+mu-Sigma_tg*mu*betagrid(k);
        g=g_noise(n,:)';
        g=g+mu*betagrid(k);
        Dg=D+Sigma_tg*g;
        
        %Note that our (g,Dg) is a valid choice of MM's sufficient
        %statistic (Z'Z)^{-1/2}Z'Y
        
        %Calculate S and T statistics as defined in Moreira and Moreira
        %(2013)
        S=(kron(b0',eye(instruments))*Sigma_standardized*kron(b0,eye(instruments)))^-.5*[g Dg]*b0;
        T=(kron(a0',eye(instruments))*Sigma_standardized^-1*kron(a0,eye(instruments)))^-.5...
            *kron(a0',eye(instruments))*Sigma_standardized^-1*[g; Dg];
        T_rep=repmat(T,1,S_approximation_draws);
        
        
        K=S'*T*(T'*T)^-1*T'*S;
        K_test(n,k)=(K>chi2inv(.95,1));
        S_test(n,k)=(S'*S>chi2inv(.95,instruments));
        mu_tilde=C_beta0*mu;
        J=S'*S-K;
        
        %Calculate QCLR test of Kelibergen (2005)
        rk=D'*Sigma_D^-1*D;
        CLR=.5*(K+J-rk+((K+J+rk).^2-4*(rk)*J).^.5);
        CLR_crit=quantile(.5*(K_size+J_size-rk+((K_size+J_size+rk).^2-4*(rk)*J_size).^.5),.95);
        CLR_test(n,k)=CLR>CLR_crit;
        
        
        %Calculate PI Test
        mu_D_hat=Sigma_D^.5*(Sigma_D^-.5*D/norm(Sigma_D^-.5*D)*max(D'*Sigma_D^-1*D-instruments,0)^.5);
        
        AR_powercheck=zeros(length(lambda_grid),1);
        lambda_grid_trimmed=lambda_grid(AR_powercheck==0);
        
        hist_est=zeros(length(lambda_grid_trimmed),tau_grid_count+1);
        cell_mean_TK=zeros(length(lambda_grid_trimmed),tau_grid_count+1);
        cell_mean_TJ=zeros(length(lambda_grid_trimmed),tau_grid_count+1);
        
        for l=1:length(lambda_grid_trimmed)
            D=D_noise2+repmat(mu_D_hat',size(D_noise2,1),1);
            m=(eye(instruments)-lambda_grid_trimmed(l)*Sigma_tg)^-1*lambda_grid_trimmed(l)*mu_D_hat;
            tau_K=(D*m).^2./(sum(D.^2,2));
            tau_J=m'*m-tau_K;
            
            hist_est(l,:)=ones(1,tau_grid_count+1)/(tau_grid_count+1);
            a=[min(tau_K) quantile(tau_K,tau_grid_count) max(tau_K)];
            cell_mean_TK(l,:)=(a(1:end-1)+a(2:end))/2;
            cell_mean_TJ(l,:)=(m'*m)-cell_mean_TK(l,:);
        end
        
        powertemp=zeros(length(lambda_grid_trimmed),size(a_grid,2));
        for na=1:size(a_grid,2)
            cond_power=interp2(TJ,TK,powerblock(:,:,na),cell_mean_TJ,cell_mean_TK,'linear',1);
            avg_power=sum(cond_power.*hist_est,2);
            powertemp(:,na)=avg_power;
        end
        
        power_max=max(powertemp,[],2);
        max_deficiency=max(repmat(power_max,1,size(powertemp,2))-powertemp,[],1);
        a=a_grid(max_deficiency<=min(max_deficiency)+10^-5);
        
        a_PI=a(end);
        PI=K+a_PI*J;
        PI_test(n,k)=PI>interp1(a_grid,a_crit,a_PI);
        astore(n,k)=a_PI;
        
        
        
        %Calculate WAP optimal test based on MM1 weights
        h_base=zeros(S_approximation_draws,1);
        h_true=0;
        D_beta0=(kron(a0',eye(instruments))*Sigma_standardized^-1*kron(a0,eye(instruments)))^-.5...
            *kron(a0',eye(instruments))*Sigma_standardized^-1*kron([beta0; 1],eye(instruments));
        Psi_beta0=kron(eye(2),eye(instruments))+...
            MM1_sigma2*[(beta0-beta0)^2*C_beta0*Phi*C_beta0 (beta0-beta0)*C_beta0*Phi*D_beta0';...
            (beta0-beta0)*D_beta0*Phi*C_beta0 D_beta0*Phi*D_beta0'];
        Psi_beta0_inv=Psi_beta0^-1;
        h_scale=T'*Psi_beta0_inv(instruments+1:end,instruments+1:end)*T;
        for m=1:b_integration_draws
            beta_temp=b_integration(m);
            D_beta=(kron(a0',eye(instruments))*Sigma_standardized^-1*kron(a0,eye(instruments)))^-.5...
                *kron(a0',eye(instruments))*Sigma_standardized^-1*kron([beta_temp; 1],eye(instruments));
            Psi_beta=kron(eye(2),eye(instruments))+...
                MM1_sigma2*[(beta_temp-beta0)^2*C_beta0*Phi*C_beta0 (beta_temp-beta0)*C_beta0*Phi*D_beta';...
                (beta_temp-beta0)*D_beta*Phi*C_beta0 D_beta*Phi*D_beta'];
            
            h_base=h_base+real((2*pi)^-instruments*det(Psi_beta)^-.5*...
                exp(-.5*sum(([S2 T_rep']*Psi_beta^-.5).^2,2)+.5*h_scale+.5*sum(S2.^2,2)))*...
                (2*pi)^(instruments/2);
            h_true=h_true+real((2*pi)^-instruments*det(Psi_beta)^-.5*...
                exp(-.5*sum(([S' T']*Psi_beta^-.5).^2,2)+.5*h_scale+.5*sum(S.^2)))*(2*pi)^(instruments/2);
        end
        obj_vec=h_base/b_integration_draws;
        MM_test_stat=h_true/b_integration_draws;
        
        options=optimset('MaxIter',10^5,'TolFun',10^-12);
        A_mat=[ones(1,S_approximation_draws)/S_approximation_draws; S2'/S_approximation_draws];
        bmat=[0.05;zeros(instruments,1)];
        [x,fval,exitflag,output,lambda]=...
            linprog(-obj_vec/S_approximation_draws,[],[],A_mat,bmat,zeros(length(obj_vec),1),ones(length(obj_vec),1),[],options);
        c0=lambda.eqlin(1);
        c1=lambda.eqlin(2:end,1);
        
        c01_store(n,k)=c0;
        c11_store(n,k,:)=permute(c1,[3,2,1]);
        exitflag_store1(n,k)=exitflag;
        MM1_stat_store(n,k)=MM_test_stat;
        MM1_test_store(n,k)=(MM_test_stat>c0+c1'*S);
        
        
        %Calculate WAP optimal test based on MM2 weights
        h_base=zeros(S_approximation_draws,1);
        h_true=0;
        l0=[0;(b0'*Omega*b0)^.5*det(Omega)^-.5];
        D_beta0=(kron(a0',eye(instruments))*Sigma_standardized^-1*kron(a0,eye(instruments)))^-.5...
            *kron(a0',eye(instruments))*Sigma_standardized^-1*kron([beta0; 1],eye(instruments));
        Psi_beta0=kron(eye(2),eye(instruments))+...
            MM2_varsigma/(l0'*l0)*[(beta0-beta0)^2*C_beta0*Phi*C_beta0 (beta0-beta0)*C_beta0*Phi*D_beta0';...
            (beta0-beta0)*D_beta0*Phi*C_beta0 D_beta0*Phi*D_beta0'];
        
        Psi_beta0_inv=Psi_beta0^-1;
        h_scale=T'*Psi_beta0_inv(instruments+1:end,instruments+1:end)*T;
        for m=1:b_integration_draws
            beta_temp=beta0+b0'*Omega*b0/(e2'*Omega*b0+tan(theta_integration(m))*det(Omega)^.5);
            b=[1; -beta_temp];
            l=[(beta_temp-beta0)*(b0'*Omega*b0)^-.5;b'*Omega*b0*(b0'*Omega*b0)^-.5*det(Omega)^-.5];
            D_beta=(kron(a0',eye(instruments))*Sigma_standardized^-1*kron(a0,eye(instruments)))^-.5...
                *kron(a0',eye(instruments))*Sigma_standardized^-1*kron([beta_temp; 1],eye(instruments));
            Psi_beta=kron(eye(2),eye(instruments))+...
                MM2_varsigma/(l'*l)*[(beta_temp-beta0)^2*C_beta0*Phi*C_beta0 (beta_temp-beta0)*C_beta0*Phi*D_beta';...
                (beta_temp-beta0)*D_beta*Phi*C_beta0 D_beta*Phi*D_beta'];
            
            h_base=h_base+real((2*pi)^-instruments*det(Psi_beta)^-.5*...
                exp(-.5*sum(([S2 T_rep']*Psi_beta^-.5).^2,2)+.5*h_scale+.5*sum(S2.^2,2)))*...
                (2*pi)^(instruments/2);
            h_true=h_true+real((2*pi)^-instruments*det(Psi_beta)^-.5*...
                exp(-.5*sum(([S' T']*Psi_beta^-.5).^2,2)+.5*h_scale+.5*sum(S.^2)))*(2*pi)^(instruments/2);
        end
        obj_vec=h_base/b_integration_draws;
        MM_test_stat=h_true/b_integration_draws;
        
        options=optimset('MaxIter',10^5,'TolFun',10^-12);
        A_mat=[ones(1,S_approximation_draws)/S_approximation_draws; S2'/S_approximation_draws];
        bmat=[0.05;zeros(instruments,1)];
        [x,fval,exitflag,output,lambda]=...
            linprog(-obj_vec/S_approximation_draws,[],[],A_mat,bmat,zeros(length(obj_vec),1),ones(length(obj_vec),1),[],options);
        c0=lambda.eqlin(1);
        c1=lambda.eqlin(2:end,1);
        
        c02_store(n,k)=c0;
        c12_store(n,k,:)=permute(c1,[3,2,1]);
        exitflag_store2(n,k)=exitflag;
        MM2_stat_store(n,k)=MM_test_stat;
        MM2_test_store(n,k)=(MM_test_stat>c0+c1'*S);
    end
end


MM1_power=mean(MM1_test_store);
MM2_power=mean(MM2_test_store);
QCLR_power=mean(CLR_test);
PI_power=mean(PI_test);
K_power=mean(K_test);
S_power=mean(S_test);

delete(gcp)


