
% This code is due to David Wingate, and can be found at 
% http://www.mit.edu/~wingated/resources.html


% ---------------------------------------------------------------------------- 
% Given a matrix A (of size m1*m2, n1*n2), find the optimal kronecker
% decomposition of the matrix.
% the following procedure finds the B,C pair that minimize
% norm( A - kron(B,C), 'fro' )**2
%
% See Van Loan and Pitsianis, "Approximation with Kronecker Products."
%

function [B,C] = krondecomp( A, m1, m2, n1, n2 )

tmpA = rearrange( A, m1, m2, n1, n2 );
[u,a,v] = svd( tmpA );
vecB = a(1,1) * u(:,1);
vecC = v(:,1);

B = vtm( vecB, m1, n1 );
C = vtm( vecC, m2, n2 );

%norm( A - kron(B,C), 'fro' )
 