function [QLR_crit, pQLR_crit] = QLR_crit_sim(h_vec,beta,beta0,beta_calc_grid,alpha,Sigma_theta_inv_rt_store,A_store,xi_mat)
%Simulates conditional critical values for QLR and pQLR tests
% moment_mat=repmat(h_vec,1,size(xi_mat,2))+A_store*xi_mat;
% 
% obj_mat=zeros(size(moment_mat,1),size(moment_mat,2));
% for n=1:size(Sigma_theta_inv_rt_store,2)
%     obj_mat=obj_mat+repmat(Sigma_theta_inv_rt_store(:,n),1,size(moment_mat,2));
% end
% AR_mat=(Summation_mat*obj_mat.^2)';

AR_mat=zeros(size(xi_mat,2),length(beta_calc_grid));
for n=1:size(xi_mat,2)
    moment_vec=h_vec+A_store*xi_mat(:,n);
    obj_vec=sum(Sigma_theta_inv_rt_store.*repmat(moment_vec,1,size(Sigma_theta_inv_rt_store,2)),2);
    AR_mat(n,:)=sum(reshape(obj_vec.^2,size(Sigma_theta_inv_rt_store,2),length(beta_calc_grid))); 
end
AR_mat=real(AR_mat);

QLR_draw=AR_mat(:,beta_calc_grid==beta0)-min(AR_mat,[],2);
pQLR_draw=AR_mat(:,beta_calc_grid==beta0)-AR_mat(:,beta_calc_grid==beta);
QLR_crit=quantile(QLR_draw,1-alpha);
pQLR_crit=quantile(pQLR_draw,1-alpha);
end

